searchData={"items":[{"type":"module","title":"TaxJar","doc":"Interact with TaxJar's API.","ref":"TaxJar.html"},{"type":"module","title":"Configuration - TaxJar","doc":"To be able to use this successfully you need to configure the required values.\n\n- `:api_key` - The API auth key for your account.\n- `:api_url` - (Optional) If you want to override the default url for the current env.\n- `:api_version` - Must be a valid TaxJar API version. Default is `\"2022-01-24\"`.\n- `:http_adapter` - Must be a module that implements the `TaxJar.Requests.HTTPBehaviour` protocol.\n                    Default is `TaxJar.Requests.HTTPAdapters.ReqAdapter`.\n- `:mode` - (Optional) You can explicitly specify the mode as `:production` or `:sandbox`.\n            The default is `:sandbox`. This will also control which url is used.","ref":"TaxJar.html#module-configuration"},{"type":"function","title":"TaxJar.fetch_env!/1","doc":"","ref":"TaxJar.html#fetch_env!/1"},{"type":"function","title":"TaxJar.get_api_key/0","doc":"","ref":"TaxJar.html#get_api_key/0"},{"type":"function","title":"TaxJar.get_api_url/0","doc":"","ref":"TaxJar.html#get_api_url/0"},{"type":"function","title":"TaxJar.get_api_version/0","doc":"","ref":"TaxJar.html#get_api_version/0"},{"type":"function","title":"TaxJar.get_env/2","doc":"","ref":"TaxJar.html#get_env/2"},{"type":"function","title":"TaxJar.get_mode/0","doc":"","ref":"TaxJar.html#get_mode/0"},{"type":"function","title":"TaxJar.get_sales_tax_for_order/1","doc":"","ref":"TaxJar.html#get_sales_tax_for_order/1"},{"type":"function","title":"TaxJar.put_env/3","doc":"","ref":"TaxJar.html#put_env/3"},{"type":"module","title":"TaxJar.Requests.Client","doc":"HTTP Client for the TaxJar API. This is the module to facilitate HTTP requests with\nthe configured HTTP adapter.","ref":"TaxJar.Requests.Client.html"},{"type":"module","title":"Configuration - TaxJar.Requests.Client","doc":"The following are relied on to make calls to the TaxJar API.\n\n- `:api_key` - Required. Must be a valid TaxJar API auth key for your account.\n- `:api_url` - Optional. If you want to override the default url for the current env.\n- `:api_version` - Optional. Must be a valid TaxJar API version. Default is `\"2022-01-24\"`.\n- `:http_adapter` - Optional. Must be a module that implements the `TaxJar.Requests.HTTPBehaviour` protocol.\n                    Default is `TaxJar.Requests.HTTPAdapters.Req`. It is read at runtime so the\n                    value can be changed on the fly.","ref":"TaxJar.Requests.Client.html#module-configuration"},{"type":"function","title":"TaxJar.Requests.Client.post/3","doc":"Perform a POST request to the API using the given payload.\n\nWhen successful the response body will be decoded into a map which is returned.","ref":"TaxJar.Requests.Client.html#post/3"},{"type":"module","title":"TaxJar.Requests.HTTPAdapters.ReqAdapter","doc":"An HTTP adapter using the `Req` library. See [the Hex docs](https://hexdocs.pm/req)\nfor more information on it's features.","ref":"TaxJar.Requests.HTTPAdapters.ReqAdapter.html"},{"type":"function","title":"TaxJar.Requests.HTTPAdapters.ReqAdapter.post/3","doc":"Perform a POST request to the API using the Req library.","ref":"TaxJar.Requests.HTTPAdapters.ReqAdapter.html#post/3"},{"type":"function","title":"Options - TaxJar.Requests.HTTPAdapters.ReqAdapter.post/3","doc":"The given options are passed to `Req.post/2`. See [the Req docs](https://hexdocs.pm/req/Req.html#new/1)\nfor all of the available options and what they do.\n\nThe following default options are provided (but can be overriden):\n\n- `auth`: The configured `:api_key` is used.\n- `base_url`: The configured `:api_url` is used.\n- `headers`: The default headers contain the configured `:api_version`.\n- `json`: The given `body` is encoded as JSON.","ref":"TaxJar.Requests.HTTPAdapters.ReqAdapter.html#post/3-options"},{"type":"function","title":"Errors - TaxJar.Requests.HTTPAdapters.ReqAdapter.post/3","doc":"When a request is not successful a `TaxJar.Requests.Error` is returned.\n\n#","ref":"TaxJar.Requests.HTTPAdapters.ReqAdapter.html#post/3-errors"},{"type":"function","title":"When the API returns an error - TaxJar.Requests.HTTPAdapters.ReqAdapter.post/3","doc":"The error fields will be as follows:\n\n- `:details`: The `Req.Response` struct received as the response.\n- `:message`: The error message as defined in the API. Default is `\"Request failed\"`.\n- `:reason`: An atom representing the status code. See `TaxJar.Requests.Error.statuses_lookup`.\n             Default is `:api_error` if the status is outside what the API supports.","ref":"TaxJar.Requests.HTTPAdapters.ReqAdapter.html#post/3-when-the-api-returns-an-error"},{"type":"behaviour","title":"TaxJar.Requests.HTTPBehaviour","doc":"Behaviour to define an HTTP adapter for the TaxJar API.","ref":"TaxJar.Requests.HTTPBehaviour.html"},{"type":"callback","title":"TaxJar.Requests.HTTPBehaviour.post/3","doc":"Perform an HTTP POST request to the given path with the given body.\n\nThe options should be utilized to the configured adapter so that one can specify\nadditional configuration like timeouts, headers, etc.","ref":"TaxJar.Requests.HTTPBehaviour.html#c:post/3"},{"type":"module","title":"TaxJar.Requests.Taxes","doc":"All the TaxJar tax API endpoints are defined in this module.","ref":"TaxJar.Requests.Taxes.html"},{"type":"function","title":"TaxJar.Requests.Taxes.get_sales_tax_for_order/1","doc":"Request sales tax for the given order.\n\nThe API response is a map with the tax liability wrapped in a map with a single\nkey `\"tax\"`. This returns the content without the wrapper.\n\nSee [Sales Tax API](https://developers.taxjar.com/api/reference/#post-calculate-sales-tax-for-an-order)\nfor details.","ref":"TaxJar.Requests.Taxes.html#get_sales_tax_for_order/1"},{"type":"exception","title":"TaxJar.Requests.Error","doc":"Exception to represent errors during communication with the TaxJar API.","ref":"TaxJar.Requests.Error.html"},{"type":"function","title":"TaxJar.Requests.Error.statuses_lookup/0","doc":"","ref":"TaxJar.Requests.Error.html#statuses_lookup/0"},{"type":"type","title":"TaxJar.Requests.Error.t/0","doc":"","ref":"TaxJar.Requests.Error.html#t:t/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}